blob: 8ef3e3edcf99fae83f8fe4156fa08146ed6c4f08 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
40 tmp_dir="${TMPDIR}/$USER/${test_dir}"
41fi
David Brazdil4846d132015-01-15 19:07:08 +000042checker="${progdir}/../tools/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043
44export JAVA="java"
Brian Carlstrom5103ce62014-03-30 16:17:42 -070045export JAVAC="javac -g"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010046export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070047export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070048export NEED_DEX="true"
jeffhao5d1ac922011-09-29 17:41:15 -070049
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070050# If dx was not set by the environment variable, assume it is in the path.
51if [ -z "$DX" ]; then
52 export DX="dx"
53fi
54
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080055# If jasmin was not set by the environment variable, assume it is in the path.
56if [ -z "$JASMIN" ]; then
57 export JASMIN="jasmin"
58fi
59
Andreas Gampe8fda9f22014-10-03 16:15:37 -070060# If smali was not set by the environment variable, assume it is in the path.
61if [ -z "$SMALI" ]; then
62 export SMALI="smali"
63fi
64
65# If dexmerger was not set by the environment variable, assume it is in the path.
66if [ -z "$DXMERGER" ]; then
67 export DXMERGER="dexmerger"
68fi
69
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080070
jeffhao5d1ac922011-09-29 17:41:15 -070071info="info.txt"
72build="build"
73run="run"
74expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -070075check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -070076output="output.txt"
77build_output="build-output.txt"
David Brazdil4846d132015-01-15 19:07:08 +000078cfg_output="cfg-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -070079lib="libartd.so"
jeffhao5d1ac922011-09-29 17:41:15 -070080run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +000081build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -070082
Alex Light9d722532014-07-22 18:07:12 -070083prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -070084target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -070085dev_mode="no"
86update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -070087debug_mode="no"
88relocate="yes"
Jeff Hao201803f2013-11-20 18:11:39 -080089runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -070090usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -070091build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -070092suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -070093trace="false"
Alex Lighte7873ec2014-08-12 09:53:50 -070094basic_verify="false"
95gc_verify="false"
96gc_stress="false"
Alex Lightbfac14a2014-07-30 09:41:21 -070097always_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -070098have_dex2oat="yes"
99have_patchoat="yes"
100have_image="yes"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700101image_suffix=""
Andreas Gampec23c9c92014-10-28 14:47:25 -0700102pic_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000103android_root="/system"
jeffhao5d1ac922011-09-29 17:41:15 -0700104
105while true; do
106 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700107 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700108 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100109 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700110 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800111 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700112 target_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800113 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700114 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700115 NEED_DEX="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100116 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700117 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800118 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700119 lib="libart.so"
120 shift
121 elif [ "x$1" = "x--dalvik" ]; then
122 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800123 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700124 shift
Alex Light03a112d2014-08-25 13:25:56 -0700125 elif [ "x$1" = "x--no-dex2oat" ]; then
126 have_dex2oat="no"
127 shift
128 elif [ "x$1" = "x--no-patchoat" ]; then
129 have_patchoat="no"
130 shift
131 elif [ "x$1" = "x--no-image" ]; then
132 have_image="no"
133 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700134 elif [ "x$1" = "x--pic-image" ]; then
135 pic_image_suffix="-pic"
136 shift
137 elif [ "x$1" = "x--pic-test" ]; then
138 run_args="${run_args} --pic-test"
139 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700140 elif [ "x$1" = "x--relocate" ]; then
141 relocate="yes"
142 shift
143 elif [ "x$1" = "x--no-relocate" ]; then
144 relocate="no"
145 shift
146 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100147 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700148 prebuild_mode="yes"
149 shift;
150 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100151 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700152 prebuild_mode="no"
153 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700154 elif [ "x$1" = "x--gcverify" ]; then
155 basic_verify="true"
156 gc_verify="true"
157 shift
158 elif [ "x$1" = "x--gcstress" ]; then
159 basic_verify="true"
160 gc_stress="true"
161 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700162 elif [ "x$1" = "x--image" ]; then
163 shift
164 image="$1"
165 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700166 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000167 elif [ "x$1" = "x-Xcompiler-option" ]; then
168 shift
169 option="$1"
170 run_args="${run_args} -Xcompiler-option $option"
171 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700172 elif [ "x$1" = "x--runtime-option" ]; then
173 shift
174 option="$1"
175 run_args="${run_args} --runtime-option $option"
176 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700177 elif [ "x$1" = "x--gdb-arg" ]; then
178 shift
179 gdb_arg="$1"
180 run_args="${run_args} --gdb-arg $gdb_arg"
181 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700182 elif [ "x$1" = "x--debug" ]; then
183 run_args="${run_args} --debug"
184 shift
185 elif [ "x$1" = "x--gdb" ]; then
186 run_args="${run_args} --gdb"
187 dev_mode="yes"
188 shift
189 elif [ "x$1" = "x--zygote" ]; then
190 run_args="${run_args} --zygote"
191 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800192 elif [ "x$1" = "x--interpreter" ]; then
193 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700194 image_suffix="-interpreter"
195 shift
196 elif [ "x$1" = "x--optimizing" ]; then
197 run_args="${run_args} -Xcompiler-option --compiler-backend=Optimizing"
198 image_suffix="-optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800199 shift
Nicolas Geoffrayc9338b92014-12-03 13:36:10 +0000200 elif [ "x$1" = "x--quick" ]; then
201 run_args="${run_args} -Xcompiler-option --compiler-backend=Quick"
202 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700203 elif [ "x$1" = "x--no-verify" ]; then
204 run_args="${run_args} --no-verify"
205 shift
206 elif [ "x$1" = "x--no-optimize" ]; then
207 run_args="${run_args} --no-optimize"
208 shift
209 elif [ "x$1" = "x--no-precise" ]; then
210 run_args="${run_args} --no-precise"
211 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700212 elif [ "x$1" = "x--invoke-with" ]; then
213 shift
214 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700215 if [ "x$what" = "x" ]; then
216 echo "$0 missing argument to --invoke-with" 1>&2
217 usage="yes"
218 break
219 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700220 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700221 shift
222 elif [ "x$1" = "x--dev" ]; then
223 run_args="${run_args} --dev"
224 dev_mode="yes"
225 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700226 elif [ "x$1" = "x--build-only" ]; then
227 build_only="yes"
228 shift
229 elif [ "x$1" = "x--output-path" ]; then
230 shift
231 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700232 if [ "x$tmp_dir" = "x" ]; then
233 echo "$0 missing argument to --output-path" 1>&2
234 usage="yes"
235 break
236 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700237 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000238 elif [ "x$1" = "x--android-root" ]; then
239 shift
240 if [ "x$1" = "x" ]; then
241 echo "$0 missing argument to --android-root" 1>&2
242 usage="yes"
243 break
244 fi
245 android_root="$1"
246 run_args="${run_args} --android-root $1"
247 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700248 elif [ "x$1" = "x--update" ]; then
249 update_mode="yes"
250 shift
251 elif [ "x$1" = "x--help" ]; then
252 usage="yes"
253 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700254 elif [ "x$1" = "x--64" ]; then
255 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700256 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700257 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200258 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700259 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200260 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700261 elif [ "x$1" = "x--always-clean" ]; then
262 always_clean="yes"
263 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800264 elif [ "x$1" = "x--dex2oat-swap" ]; then
265 run_args="${run_args} --dex2oat-swap"
266 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700267 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700268 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700269 usage="yes"
270 break
271 else
272 break
273 fi
274done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700275
276# tmp_dir may be relative, resolve.
277#
278# Cannot use realpath, as it does not exist on Mac.
279# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700280# Cannot use readlink -m, as it does not exist on Mac.
281# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700282noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700283tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700284mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700285
Alex Lighte7873ec2014-08-12 09:53:50 -0700286if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800287 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
288 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700289fi
290if [ "$gc_verify" = "true" ]; then
291 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
292fi
293if [ "$gc_stress" = "true" ]; then
294 run_args="${run_args} --runtime-option -Xgc:SS --runtime-option -Xms2m --runtime-option -Xmx2m"
295fi
Jeff Hao85139a32014-07-23 11:52:52 -0700296if [ "$trace" = "true" ]; then
297 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin --runtime-option -Xmethod-trace-file-size:2000000"
298fi
299
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700300# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100301# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700302function guess_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100303 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800304 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700305 if [ "x${suffix64}" = "x64" ]; then
306 target_arch_name=${grep64bit}
307 else
308 target_arch_name=${grep32bit}
309 fi
310}
311
Alex Lighta59dd802014-07-02 16:28:08 -0700312if [ "$target_mode" = "no" ]; then
313 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700314 if [ "$prebuild_mode" = "yes" ]; then
315 echo "--prebuild with --jvm is unsupported";
316 exit 1;
317 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700318 fi
319fi
320
Alex Light03a112d2014-08-25 13:25:56 -0700321if [ "$have_patchoat" = "no" ]; then
322 run_args="${run_args} --no-patchoat"
323fi
324
325if [ "$have_dex2oat" = "no" ]; then
326 run_args="${run_args} --no-dex2oat"
327fi
328
Jeff Hao201803f2013-11-20 18:11:39 -0800329if [ ! "$runtime" = "jvm" ]; then
330 run_args="${run_args} --lib $lib"
331fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700332
Jeff Hao201803f2013-11-20 18:11:39 -0800333if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700334 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100335 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700336 bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
337 run_args="${run_args} --boot -Xbootclasspath:${bpath}"
338 else
339 true # defaults to using target BOOTCLASSPATH
340 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800341elif [ "$runtime" = "art" ]; then
342 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100343 # ANDROID_BUILD_TOP and ANDROID_HOST_OUT are not set in a build environment.
Brian Carlstrom43534862014-02-19 01:13:52 -0800344 if [ -z "$ANDROID_BUILD_TOP" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100345 export ANDROID_BUILD_TOP=$oldwd
Brian Carlstrom43534862014-02-19 01:13:52 -0800346 fi
347 if [ -z "$ANDROID_HOST_OUT" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100348 export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86
Brian Carlstrom43534862014-02-19 01:13:52 -0800349 fi
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000350 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}.art"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700351 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800352 else
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700353 guess_arch_name
354 run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000355 run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800356 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700357 if [ "$relocate" = "yes" ]; then
358 run_args="${run_args} --relocate"
359 else
360 run_args="${run_args} --no-relocate"
361 fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700362fi
363
Alex Light03a112d2014-08-25 13:25:56 -0700364if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700365 if [ "$runtime" != "art" ]; then
366 echo "--no-image is only supported on the art runtime"
367 exit 1
368 fi
369 if [ "$target_mode" = "no" ]; then
370 framework="${ANDROID_HOST_OUT}/framework"
371 bpath_suffix="-hostdex"
372 else
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000373 framework="${android_root}/framework"
Alex Light1ef4ce82014-08-27 11:13:47 -0700374 bpath_suffix=""
375 fi
376 # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will
377 # fail since these jar files will be stripped.
378 bpath="${framework}/core-libart${bpath_suffix}.jar"
379 bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar"
380 bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar"
381 bpath="${bpath}:${framework}/core-junit${bpath_suffix}.jar"
382 bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar"
383 # Pass down the bootclasspath
384 run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}"
Alex Light03a112d2014-08-25 13:25:56 -0700385 run_args="${run_args} --no-image"
386fi
387
jeffhao5d1ac922011-09-29 17:41:15 -0700388if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
389 echo "--dev and --update are mutually exclusive" 1>&2
390 usage="yes"
391fi
392
393if [ "$usage" = "no" ]; then
394 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
395 test_dir=`basename "$oldwd"`
396 else
397 test_dir="$1"
398 fi
399
400 if [ '!' -d "$test_dir" ]; then
401 td2=`echo ${test_dir}-*`
402 if [ '!' -d "$td2" ]; then
403 echo "${test_dir}: no such test directory" 1>&2
404 usage="yes"
405 fi
406 test_dir="$td2"
407 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700408 # Shift to get rid of the test name argument. The rest of the arguments
409 # will get passed to the test run.
410 shift
411fi
412
413if [ "$usage" = "yes" ]; then
414 prog=`basename $prog`
415 (
416 echo "usage:"
417 echo " $prog --help Print this message."
418 echo " $prog [options] [test-name] Run test normally."
419 echo " $prog --dev [options] [test-name] Development mode" \
420 "(dumps to stdout)."
421 echo " $prog --update [options] [test-name] Update mode" \
422 "(replaces expected.txt)."
423 echo ' Omitting the test name or specifying "-" will use the' \
424 "current directory."
425 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000426 echo " -O Run non-debug rather than debug build (off by default)."
427 echo " -Xcompiler-option Pass an option to the compiler."
428 echo " --runtime-option Pass an option to the runtime."
429 echo " --debug Wait for a debugger to attach."
430 echo " --gdb Run under gdb; incompatible with some tests."
431 echo " --build-only Build test files only (off by default)."
432 echo " --interpreter Enable interpreter only mode (off by default)."
433 echo " --optimizing Enable optimizing compiler (off by default)."
Nicolas Geoffrayc9338b92014-12-03 13:36:10 +0000434 echo " --quick Use Quick compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000435 echo " --no-verify Turn off verification (on by default)."
436 echo " --no-optimize Turn off optimization (on by default)."
437 echo " --no-precise Turn off precise GC (on by default)."
438 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700439 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000440 echo " other runtime options are ignored."
441 echo " --no-dex2oat Run as though dex2oat was failing."
442 echo " --no-patchoat Run as though patchoat was failing."
443 echo " --prebuild Run dex2oat on the files before starting test. (default)"
444 echo " --no-prebuild Do not run dex2oat on the files before starting"
445 echo " the test."
446 echo " --relocate Force the use of relocating in the test, making"
447 echo " the image and oat files be relocated to a random"
448 echo " address before running. (default)"
449 echo " --no-relocate Force the use of no relocating in the test"
450 echo " --host Use the host-mode virtual machine."
451 echo " --invoke-with Pass --invoke-with option to runtime."
452 echo " --dalvik Use Dalvik (off by default)."
453 echo " --jvm Use a host-local RI virtual machine."
454 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700455 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000456 echo " --64 Run the test in 64-bit mode"
457 echo " --trace Run with method tracing"
458 echo " --gcstress Run with gc stress testing"
459 echo " --gcverify Run with gc verification"
460 echo " --always-clean Delete the test files even if the test fails."
461 echo " --android-root [path] The path on target for the android root. (/system by default)."
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800462 echo " --dex2oat-swap Use a dex2oat swap file."
jeffhao5d1ac922011-09-29 17:41:15 -0700463 ) 1>&2
464 exit 1
465fi
466
467cd "$test_dir"
468test_dir=`pwd`
469
470td_info="${test_dir}/${info}"
471td_expected="${test_dir}/${expected}"
472
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700473if [ ! -r $td_info ]; then
474 echo "${test_dir}: missing file $td_info" 1>&2
475 exit 1
476fi
477
478if [ ! -r $td_expected ]; then
479 echo "${test_dir}: missing file $td_expected" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700480 exit 1
481fi
482
483# copy the test to a temp dir and run it
484
Elliott Hughes510c8782011-10-06 10:57:34 -0700485echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700486
487rm -rf "$tmp_dir"
488cp -Rp "$test_dir" "$tmp_dir"
489cd "$tmp_dir"
490
491if [ '!' -r "$build" ]; then
492 cp "${progdir}/etc/default-build" build
493fi
494
495if [ '!' -r "$run" ]; then
496 cp "${progdir}/etc/default-run" run
497fi
498
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700499if [ '!' -r "$check_cmd" ]; then
500 cp "${progdir}/etc/default-check" check
501fi
502
jeffhao5d1ac922011-09-29 17:41:15 -0700503chmod 755 "$build"
504chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700505chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700506
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700507export TEST_NAME=`basename ${test_dir}`
508
David Brazdil4846d132015-01-15 19:07:08 +0000509# Tests named '<number>-checker-*' will also have their CFGs verified with
510# Checker when compiled with Optimizing on host.
511if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
512 # Build Checker DEX files without dx's optimizations so the input to dex2oat
513 # better resembles the Java source. We always build the DEX the same way, even
514 # if Checker is not invoked and the test only runs the program.
515 build_args="${build_args} --dx-option --no-optimize"
516
517 if [ "$runtime" = "art" -a "$image_suffix" = "-optimizing" -a "$target_mode" = "no" ]; then
518 run_checker="yes"
519 run_args="${run_args} -Xcompiler-option --dump-cfg=$tmp_dir/$cfg_output \
520 -Xcompiler-option -j1"
521 fi
522fi
523
Ian Rogers997f0f92014-06-21 22:58:05 -0700524# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
525file_size_limit=2048
526if echo "$test_dir" | grep 089; then
527 file_size_limit=5120
528elif echo "$test_dir" | grep 083; then
529 file_size_limit=5120
530fi
Alex Lighta59dd802014-07-02 16:28:08 -0700531if ! ulimit -S "$file_size_limit"; then
Ian Rogers997f0f92014-06-21 22:58:05 -0700532 echo "ulimit file size setting failed"
533fi
534
jeffhao5d1ac922011-09-29 17:41:15 -0700535good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000536good_build="yes"
537good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700538if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000539 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700540 build_exit="$?"
541 echo "build exit status: $build_exit" 1>&2
542 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800543 echo "${test_dir}: running..." 1>&2
544 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700545 run_exit="$?"
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800546 echo "run exit status: $run_exit" 1>&2
547 if [ "$run_exit" = "0" ]; then
548 good="yes"
549 fi
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700550 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700551elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000552 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700553 build_exit="$?"
554 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800555 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700556 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000557 if [ "$run_checker" = "yes" ]; then
558 "$checker" -q "$cfg_output" "$tmp_dir" >> "$output" 2>&1
559 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700560 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
561 good="yes"
562 else
563 cat "$build_output" 1>&2
564 echo "build exit status: $build_exit" 1>&2
565 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700566elif [ "$build_only" = "yes" ]; then
567 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000568 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700569 build_exit="$?"
570 if [ "$build_exit" '!=' '0' ]; then
571 cp "$build_output" "$output"
572 echo "build exit status: $build_exit" >>"$output"
573 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
574 if [ "$?" '!=' "0" ]; then
575 good="no"
576 echo "BUILD FAILED For ${TEST_NAME}"
577 fi
578 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700579 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700580 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700581 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700582else
David Brazdil4846d132015-01-15 19:07:08 +0000583 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700584 build_exit="$?"
585 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800586 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700587 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000588 run_exit="$?"
589 if [ "$run_exit" != "0" ]; then
590 echo "run exit status: $run_exit" 1>&2
591 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000592 elif [ "$run_checker" = "yes" ]; then
593 "$checker" -q "$cfg_output" "$tmp_dir" >> "$output" 2>&1
594 checker_exit="$?"
595 if [ "$checker_exit" != "0" ]; then
596 echo "checker exit status: $checker_exit" 1>&2
597 good_run="no"
598 else
599 good_run="yes"
600 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000601 else
602 good_run="yes"
603 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700604 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000605 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700606 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700607 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
608 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700609 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700610 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700611 max_name_length=$(getconf NAME_MAX ${tmp_dir})
612 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
613 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700614 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700615 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700616 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700617 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000618 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
619 # output == expected
620 good="yes"
621 echo "${test_dir}: succeeded!" 1>&2
622 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700623 fi
624fi
625
jeffhao5d1ac922011-09-29 17:41:15 -0700626(
Alex Lightbfac14a2014-07-30 09:41:21 -0700627 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700628 echo "${test_dir}: FAILED!"
629 echo ' '
630 echo '#################### info'
631 cat "${td_info}" | sed 's/^/# /g'
632 echo '#################### diffs'
Ian Rogers75deec02014-11-23 20:07:39 -0800633 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 2000
jeffhao5d1ac922011-09-29 17:41:15 -0700634 echo '####################'
635 echo ' '
636 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700637
638) 1>&2
639
640# Clean up test files.
641if [ "$always_clean" = "yes" -o "$good" = "yes" ]; then
642 cd "$oldwd"
643 rm -rf "$tmp_dir"
644 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
645 adb shell rm -rf $DEX_LOCATION
646 fi
647 if [ "$good" = "yes" ]; then
648 exit 0
649 fi
650fi
651
652
653(
654 if [ "$always_clean" = "yes" ]; then
655 echo "${TEST_NAME} files deleted from host "
656 if [ "$target_mode" == "yes" ]; then
657 echo "and from target"
658 fi
659 else
660 echo "${TEST_NAME} files left in ${tmp_dir} on host"
661 if [ "$target_mode" == "yes" ]; then
662 echo "and in ${DEX_LOCATION} on target"
663 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700664 fi
665
jeffhao5d1ac922011-09-29 17:41:15 -0700666) 1>&2
667
668exit 1